<template>
  <v-app class="accountantDynamicReport">
    <v-container style="padding: 20px">
      <div class="accountantDynamicReport__title">
        <h1>Отчёт годовой стоимости оказанных услуг </h1>
      </div>
      <div class="accountantDynamicReport__subtitle">
        <h2>Нажмите для создания отчёта</h2>
      </div>

      <v-dialog v-model="dialog" max-width="500px">
        <template v-slot:activator="{ on, attrs }">
          <v-btn class="accountantDynamicReport__btn" v-bind="attrs" v-on="on" style="margin-right: auto"
                 @click="loadPage">Создать
          </v-btn>
        </template>
        <v-card>
          <v-card-title>
            <span class="text-h5">{{ "Получить отчёт" }}</span>
          </v-card-title>

          <v-card-text>
            <v-container>
              <v-row>
                <v-col cols="12" sm="6" md="12">
                  <v-text-field v-model="dialogItem.year" item-value="year" label="Год"></v-text-field>
                </v-col>
                <v-col cols="12" sm="6" md="12">
                  <v-select v-model="dialogItem.mounth" :items="mounths" label="Месяца" multiple>
                    <v-list-item
                        ripple
                        @mousedown.prevent
                        @click="toggleMounth"
                    >
                      <v-list-item-action>
                        <v-icon :color="selectedMounth.length > 0 ? 'indigo darken-4' : ''">
                          {{ icon }}
                        </v-icon>
                      </v-list-item-action>
                      <v-list-item-content>
                        <v-list-item-title>
                          Select All
                        </v-list-item-title>
                      </v-list-item-content>
                    </v-list-item>
                  </v-select>
                </v-col>
                <v-col cols="12" sm="6" md="12">
                  <v-select v-model="dialogItem.service" :items="services" item-value="id" item-text="name"
                            label="Услуга" multiple>
                    <v-list-item
                        ripple
                        @mousedown.prevent
                        @click="toggleService"
                    >
                      <v-list-item-action>
                        <v-icon :color="selectedservice.length > 0 ? 'indigo darken-4' : ''">
                          {{ icon }}
                        </v-icon>
                      </v-list-item-action>
                      <v-list-item-content>
                        <v-list-item-title>
                          Select All
                        </v-list-item-title>
                      </v-list-item-content>
                    </v-list-item>
                  </v-select>
                </v-col>
              </v-row>
            </v-container>
          </v-card-text>

          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="#AFFFCF" @click="close">
              Закрыть
            </v-btn>
            <v-btn color="#AFFFCF" @click="requestReport">
              Получить отчет
            </v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <div v-if="this.checker">
        <v-col cols="12">
          <iframe id="frame" type="application/pdf" :src="this.pdfsrc" style="width: 100%; height: 620px">
          </iframe>
        </v-col>
      </div>
      <div v-else>
      </div>
    </v-container>
  </v-app>
</template>

<script>
import axios from "axios";

export default {
  name: "AccountantDynamicReport",
  data() {
    return {
      dialog: false,
      checker: false,
      pdfsrc: '',
      mounths: ['Январь', 'Февраль', 'Март', 'Апрель', 'Май', 'Июнь', 'Июль', 'Август', 'Сентябрь', 'Октябрь', 'Ноябрь', 'Декабрь'],
      services: [],
      servicesNames: [],
      selectedMounth: [],
      selectedservice: [],

      dialogItem: {
        year: 'YYYY',
        mounth: '',
        service: '',
      },
    }
  },

  computed: {
    likesAllFruit() {
      return this.selectedMounth.length === this.mounths.length
    },
    likesSomeFruit() {
      return this.selectedMounth.length > 0 && !this.likesAllFruit
    },
    icon() {
      if (this.likesAllFruit) return 'mdi-close-box'
      if (this.likesSomeFruit) return 'mdi-minus-box'
      return 'mdi-checkbox-blank-outline'
    },
  },

  mounted() {
    this.fetchDynamicAccountantReport()
  },

  methods: {
    async fetchDynamicAccountantReport() {
      axios
          .get(this.$root.globalVar + '/service')
          .then(response => {
            this.servicesNames = response.data
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })
    },

    async fetchReport(item) {
      console.log(item)
      axios
          .post(this.$root.globalVar + '/reports/accountant/dynamic_report', {
            year: parseInt(item.year),
            months: item.mounth,
            ids: item.service
          }, {
            responseType: "blob"
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })
          .then(response => {
            console.log("Success", response);
            const blob = new Blob([response.data], {type: 'application/pdf'});
            console.log(blob)
            const objectUrl = URL.createObjectURL(blob);
            this.pdfsrc = objectUrl;
            console.log(objectUrl);
            window.open(objectUrl)
            this.checker = true;
          })
    },

    toggleMounth() {
      this.$nextTick(() => {
        if (this.likesAllFruit) {
          this.selectedMounth = []
        } else {
          this.selectedMounth = this.mounths.slice()
        }
      })
    },

    toggleService() {
      this.$nextTick(() => {
        if (this.likesAllFruit) {
          this.selectedservice = []
        } else {
          this.selectedservice = this.services.slice()
        }
      })
    },

    loadPage() {
      this.servicesNames.forEach(service => this.services.push(service))
    },


    close() {
      this.dialog = false
    },

    requestReport() {
      this.fetchReport(this.dialogItem)
      this.dialog = false
    }
  }

}
</script>

<style lang="scss" scoped>
.accountantDynamicReport {
  &__title {
    text-align: center;
    margin: 60px 0 30px 0;
  }

  &__subtitle {
    margin: 0 0 20px 50px;
  }

  &__btn {
    margin-left: 50px;
  }
}
</style>